import { Store as BaseStore } from '../store';
import { SelectorPaths, SelectorValue } from '../helpers/stringSelector';
import { UseStorePropResult } from './useStoreProp';
import { UseStoreStateOptions } from './useStoreState';
export declare class Store<T> extends BaseStore<T> {
    useState(options?: {
        throttle?: number;
    }): T;
    useState<S>(selector: (state: T) => S, dependencies?: any[], options?: UseStoreStateOptions): S;
    useState<K extends SelectorPaths<T>>(selector: K, options?: UseStoreStateOptions): SelectorValue<T, K>;
    useProp<K extends SelectorPaths<T>>(selector: K): UseStorePropResult<T, K>;
}
