import { Draft, Patch } from 'immer';
import { Cancel } from './helpers/misc';
export declare class Store<T> {
    private state;
    private options;
    private subscriptions;
    private reactions;
    private patches;
    private inversePatches;
    private notifyScheduled;
    private lock?;
    constructor(state: T, options?: {
        log: (...data: any[]) => void;
    });
    getState(): T;
    update(update: (draft: Draft<T>, original: T) => Draft<T> | void | undefined): void;
    set(state: T): void;
    applyPatches(patches: Patch[]): void;
    subscribe<S>(selector: (state: T) => S, listener: (value: S, prev: S | undefined, state: T) => void, { runNow, throttle }?: {
        runNow?: boolean | undefined;
        throttle?: number | undefined;
    }): Cancel;
    addReaction<S>(selector: (state: T) => S, reaction: (value: S, draft: Draft<T>, original: T, prev: S) => void, { runNow }?: {
        runNow?: boolean | undefined;
    }): Cancel;
    subscribePatches(listener: (patches: Patch[], inversePatches: Patch[]) => void): Cancel;
    private checkLock;
    private notify;
}
